//+------------------------------------------------------------------+
//|                                                   T3MA_ALARM.mq4 |
//|                                     Copyright  2011, Martingeil |
//|                                                    fx.09@mail.ru | 
//+------------------------------------------------------------------+
// Martingeil,       .
#property copyright "Copyright  2011, Martingeil  edit by www.expforex.com"
#property link      "fx.09@mail.ru  edit by www.expforex.com"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  Blue
#property  indicator_color2  Red
//---- indicator parameters
extern int  period = 4; //12
extern int  shift  = 0; //  
//---- indicator buffers
double BufferUp[],BufferDn[];
int q,st=5;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW,2);
   SetIndexArrow(0,233);
   SetIndexStyle(1,DRAW_ARROW,2);
   SetIndexArrow(1,234);

   SetIndexBuffer(0,BufferUp);//  
   SetIndexBuffer(1,BufferDn);//  
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("T3MA-ALARM ("+period+")");
//---- initialization done
   if(Digits==3 || Digits==5) q=10;
   st=st*q;
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("low");
   ObjectDelete("high");
  }

//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
extern string Alerts="    www.expforex.com";
extern bool AlerT=true;  //              
extern bool Mail=true;   //           
extern bool Push=true;   //    
extern bool Arrow=true;  //    
extern int shiftalert=1;      //      0 -   1 -  
int timeee;              //  
string nameInd;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetArrow(int cd,color cl,
              string nm="",datetime t1=0,double p1=0,int sz=3)
  {
   if(nm=="") nm=DoubleToStr(Time[0],0);
   if(t1<=0) t1=Time[0];
   if(p1<=0) p1=Bid;
   nameInd=WindowExpertName();
   int wind=WindowFind(nameInd);
//if(wind==-1)

   wind=0;
   if(ObjectFind(nm)<0) ObjectCreate(nm,OBJ_ARROW,wind,0,0);
   ObjectSet(nm,OBJPROP_TIME1,t1);
   ObjectSet(nm,OBJPROP_PRICE1,p1);
   ObjectSet(nm,OBJPROP_ARROWCODE,cd);
   ObjectSet(nm,OBJPROP_COLOR,cl);
   ObjectSet(nm,OBJPROP_WIDTH,sz);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Expforex_AlertArrow(string text="",int arrowdir=0,bool history=false,int i=0)
  {
   nameInd=WindowExpertName();
   int wind=WindowFind(nameInd);
   if(wind==-1)wind=0;
   ObjectCreate("Originalalert",OBJ_LABEL,wind,0,0);
   ObjectSetText("Originalalert"," AlertArrow www.expforex.com",10,"Arial Bold",Red);
   ObjectSet("Originalalert",OBJPROP_CORNER,2);
   ObjectSet("Originalalert",OBJPROP_XDISTANCE,200);
   ObjectSet("Originalalert",OBJPROP_YDISTANCE,10);

   if(!history)
     {
      if(AlerT) Alert(text);
      if(Arrow) if(arrowdir==1) SetArrow(241,Blue,nameInd+DoubleToStr(Time[shiftalert],0),Time[shiftalert],Low[shiftalert]);
      if(Arrow) if(arrowdir==2) SetArrow(242,Red,nameInd+DoubleToStr(Time[shiftalert],0),Time[shiftalert],High[shiftalert]);
      if(!IsTesting())if(Mail) SendMail(text,text);
      if(!IsTesting())if(Push) SendNotification(text);
     }
   if(history)
     {
      //  Print(i+"arrowdir="+arrowdir);
      if(Arrow) if(arrowdir==1) SetArrow(241,Blue,nameInd+DoubleToStr(Time[shiftalert+i],0),Time[shiftalert+i],Low[shiftalert+i]);
      if(Arrow) if(arrowdir==2) SetArrow(242,Red,nameInd+DoubleToStr(Time[shiftalert+i],0),Time[shiftalert+i],High[shiftalert+i]);

     }

  }
//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+




//+----------------------------------------------------------------------+
//| Moving Average of Oscillator                                         |
//+----------------------------------------------------------------------+
int start()
  {
//---- ArraySetAsSeries --------------------------------------------------  
   double Ma[9999],MaOn[9999];
   double y0[9999],y1[9999],y2[9999];
   int    i,limit=ArraySize(Ma);
   ArraySetAsSeries(Ma,true);
//---- IndicatorCounted --------------------------------------------------
   int    counted_bars=IndicatorCounted();
   int    limit1=Bars-counted_bars;
   if(limit1>1){limit1=Bars-period-1;}
//---- EMA --------------------------------------------------------------- 
   for(i=limit1; i>=0; i--)  Ma[i]  =iMA(NULL,0,period,0,MODE_EMA,PRICE_CLOSE,i);
   for(i=limit1; i>=0; i--)  MaOn[i]=iMAOnArray(Ma,limit,period,0,MODE_EMA,i);

   for(i=limit1; i>=0; i--)
     {
      y0[i+shift]=MaOn[i+shift];
      y1[i+1+shift]=MaOn[i+1+shift];
      y2[i+2+shift]=MaOn[i+2+shift];

      if(y0[i+shift]-y1[i+1+shift]<0 && y1[i+1+shift]-y2[i+2+shift]>0){BufferDn[i+1]=High[i+1]+st*Point;}
      if(y0[i+shift]-y1[i+1+shift]>0 && y1[i+1+shift]-y2[i+2+shift]<0){BufferUp[i+1]=Low[i+1]-st*Point;}
      //---- Signal Trend Up || Dn ---------------------------------------------   
      if(y0[i]-y1[i+1]>0) Comment("\n SWAPLONG = ",MarketInfo(Symbol(),MODE_SWAPLONG),
         "   SWAPSHORT = ",MarketInfo(Symbol(),MODE_SWAPSHORT),"\n BUY TREND ",DoubleToStr(Close[i],Digits));

      else if(y0[i]-y1[i+1]<0) Comment("\n SWAPLONG = ",MarketInfo(Symbol(),MODE_SWAPLONG),
         "   SWAPSHORT = ",MarketInfo(Symbol(),MODE_SWAPSHORT),"\n SELL TREND ",DoubleToStr(Close[i],Digits));
     }



//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
   nameInd=WindowExpertName();
   if(timeee!=Time[0] && BufferUp[shiftalert]!=EMPTY_VALUE)
     {

      Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" UP",1);
      timeee=Time[0];
     }

   if(timeee!=Time[0] && BufferDn[shiftalert]!=EMPTY_VALUE)
     {
      Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" DN",2);
      timeee=Time[0];
     }
//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+

//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
   if(counted_bars>0) counted_bars--;
   int limit2=Bars-counted_bars;
   for(int i2=0; i2<limit2; i2++)
     {
      nameInd=WindowExpertName();
      if( BufferUp[shiftalert+i2]!=EMPTY_VALUE)
        {
         Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" UP"+i2,1,true,i2);
        }

      if(BufferDn[shiftalert+i2]!=EMPTY_VALUE)
        {
         Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" DN"+i2,2,true,i2);
        }
     }
//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+




//---- done
   return(0);
  }
//+---------------------------------------------------------------------+
